package sample.test.pen.logic;

import java.util.Iterator;

import sample.test.pen.DrawPath;
import sample.test.pen.Path;

import jp.digitalmuseum.mr.resource.Pen.STATUS;
import jp.digitalmuseum.mr.task.EndPen;
import jp.digitalmuseum.mr.task.Move;
import jp.digitalmuseum.mr.task.PutPen;
import jp.digitalmuseum.utils.Position;
import jp.digitalmuseum.utils.ScreenPosition;

public class DrawPath_2_AsLines extends DrawPath {
	private Iterator<ScreenPosition> pathIterator;
	private Position departure;
	private Position destination;

	public DrawPath_2_AsLines(Path path) {
		this.pathIterator = path.iterator();
		destination = new Position();
		departure = new Position();
		departure.setNotFound(true);
	}

	@Override
	protected void behave() {
		if (pathIterator.hasNext()) {
			if (!departure.isNotFound() && getPen().getStatus() == STATUS.UP) {
				PutPen putPen = new PutPen();
				putPen.setDefaultTransition(this);
				delegateToTask(putPen);
			}
			else {
				final ScreenPosition nextScreenPosition = pathIterator.next();
				getLocationProvider().getCoordProvider().screenToRealOut(
						nextScreenPosition, destination);
				if (departure.isNotFound()) {
					Move moveTo = new Move(destination);
					moveTo.setDefaultTransition(this);
					delegateToTask(moveTo);
				}
				else {
					DrawLine drawLine = new DrawLine(departure, destination);
					drawLine.setDefaultTransition(this);
					delegateToTask(drawLine);
				}
				departure.set(destination);
			}
		}
		else if (getPen().getStatus() == STATUS.DOWN) {
			EndPen endPen = new EndPen();
			endPen.setDefaultTransition(this);
			delegateToTask(endPen);
		}
		else {
			fireDefaultTransition();
		}
	}

}
